//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#define __MACTYPES__
#define ZLIB_WINAPI
#include "zlib.h"

#include "acefile.h"

#pragma package(smart_init)
//---------------------------------------------------------------------------

const int NORMALZLIBBUFSIZE = 8192*1024;

enum { ACE_DXT_FLAG=0x10, ACE_MIPMAP_FLAG=1 };          // for check ACE head

//---------------------------------------------------------------------------
// For make AceHead

unsigned char UnknownStr[16] =
{
  0x55, 0x6e, 0x6b, 0x6e, 0x6f, 0x77, 0x6e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

unsigned char MakeAceMemo[80] =
{
  0x41, 0x43, 0x45, 0x20, 0x66, 0x69, 0x6c, 0x65, 0x20, 0x63, 0x72, 0x65, 0x61, 0x74, 0x65, 0x64,
  0x20, 0x62, 0x79, 0x20, 0x4d, 0x61, 0x6b, 0x65, 0x41, 0x43, 0x45, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

signed char MakeAceDxtMemo[80] =
{
  0x41, 0x43, 0x45, 0x20, 0x66, 0x69, 0x6c, 0x65, 0x20, 0x63, 0x72, 0x65, 0x61, 0x74, 0x65, 0x64,
  0x20, 0x62, 0x79, 0x20, 0x63, 0x6f, 0x6d, 0x70, 0x61, 0x63, 0x65, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};

unsigned char FixedTail[100] =          // Fixed tail size: Opaque=68 Trans=84 Alpha=100
{                                       // 0 0 0_ 8 3 8 4 8 5, 1 2, 8 6
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00,
  0x00, 0x00, 0x00, 0x00
};

//---------------------------------------------------------------------------

int AceInfo::EstDXTFileSize()
{
        int size;

        if( width!=height ) return 0;
        switch( width ) {
/*                case 4:
                        size = 155;
                        break;
                case 8:
                        size = 191;
                        break;
                case 16:
                        size = 323;
                        break;                  */
                case 32:
                        size = 951;
                        break;
                case 64:
                        size = 3007;
                        break;
                case 128:
                        size = 11207;
                        break;
                case 256:
                        size = 43983;
                        break;
                case 512:
                        size = 175063;
                        break;
                case 1024:
                        size = 699359;
                        break;
                default:
                        return 0;
         }

        if( colorDepth!=Opaque )
                size += 19;
        return size;
}
//---------------------------------------------------------------------------

AceInfo AceFile::GetInfo(AnsiString FileName)
{
        int handle=-1,readsize=512,zcode;
        unsigned long zbufsize=2048;
        unsigned char *readbuf=NULL;
        unsigned char *zlibbuf=NULL;

        fileName = FileName;
        colorDepth = Unknown;

    try {
        // open file
        handle = FileOpen(fileName,fmOpenRead);
        if( handle==-1 ) {
                infoMsg = "Can not open file!";
                ShowMessage(infoMsg);
                return AceInfo(*this);
          }

        // alloc memory for buf
        readbuf = new unsigned char[readsize];
        zlibbuf = new unsigned char[zbufsize];
        if( readbuf==NULL || zlibbuf==NULL ) {
                OutOfMemoryError();                     // throw EOutOfMemory
                return AceInfo(*this);
         }

        // read file head and size
        fileSize = FileSeek(handle,0,2);
        FileSeek(handle,0,0);           // reset position
        readsize = FileRead(handle,readbuf,readsize);
        if( readsize <= 20 ) {          // File too small
                infoMsg = "File too small!";
                ShowMessage(infoMsg);
                return AceInfo(*this);
          }

        // if necessary ZLib decompress head
        kujuHead = (KujuFileHead *)readbuf;
        if( !kujuHead->isKujuHead() ) {
                infoMsg = "Not kuju file!";
                ShowMessage(infoMsg);
                return AceInfo(*this);
         }
        if( kujuHead->isZCompressed() ) {
                zcode = uncompress(zlibbuf,&zbufsize,readbuf+sizeof(KujuFileHead),
                                readsize-sizeof(KujuFileHead));

                if( zcode!=Z_OK && zcode!=Z_BUF_ERROR && zcode!=Z_DATA_ERROR) {
                        infoMsg = "Decompress failure!";
                        ShowMessage(infoMsg);
                        return AceInfo(*this);         // Decompress ZLib data error;
                 }

                if( zbufsize <= sizeof(AceHead) ) {          // File too small
                        infoMsg = "Decompressed data too small!";
                        ShowMessage(infoMsg);
                        return AceInfo(*this);
                 }

                aceHead = (AceHead *)zlibbuf;
                isZLib = true;
         }
        else {
                if( readsize <= sizeof(AceHead)+sizeof(KujuFileHead) ) {          // File too small
                        infoMsg = "File too small!";
                        ShowMessage(infoMsg);
                        return AceInfo(*this);
                 }
                aceHead = (AceHead *)(readbuf+sizeof(KujuFileHead));
                isZLib = false;
         }

        parseHeader();

        if( !errorMsg.IsEmpty() ) {
                ShowMessage(errorMsg);
                infoMsg += errorMsg;
         }
    }
    __finally {
        if( handle!=-1 ) FileClose(handle);
        if( readbuf!=NULL ) delete readbuf;
        if( zlibbuf!=NULL ) delete zlibbuf;
     }

        return AceInfo(*this);
}

//---------------------------------------------------------------------------

void AceFile::parseHeader()
{
        // Detect header error
        if( aceHead->fileType!=1 ) {
                errorMsg = "Wrong file type, not texture :"+AnsiString(aceHead->fileType);
                return;
         }
        if( aceHead->colorDepth<3 || aceHead->colorDepth>5 ) {
                errorMsg = "Wrong color depth:"+AnsiString(aceHead->colorDepth);
                return;
         }

        // Get info from header
        isDXT1 = aceHead->textureType & ACE_DXT_FLAG;
        hasMIPMAP = aceHead->textureType & ACE_MIPMAP_FLAG;

        if( !isDXT1 ) {
                if( isZLib ) compressType = ZLib;
                else compressType = NoCompress;
         }
        else {
                if( isZLib ) compressType = DXT1ZLib;
                else compressType = DXT1;
         }
        colorDepth = (ACEColorDepths)(aceHead->colorDepth-3);
        width = aceHead->width;
        height = aceHead->height;

        headerSize = sizeof(AceHead)+16*colorDepth;
        MemoStr = aceHead->MemoString;

        infoMsg = AnsiString(width)+"x"+AnsiString(height);
        if( isDXT1 ) {
                infoMsg += " DXT1";
                if( isZLib ) infoMsg += "&ZLib";

                if( colorDepth==Trans ) infoMsg += " Alpha";
                else if( colorDepth==Alpha ) infoMsg += " Alpha?";

                if( !hasMIPMAP ) infoMsg += " no MIP!";
         }
        else {
                if( colorDepth==Trans ) infoMsg += " Trans";
                else if( colorDepth==Alpha ) infoMsg += " Alpha";

                if( hasMIPMAP ) infoMsg += " MIP";

                if( isZLib ) infoMsg += " ZLib";
         }
        infoMsg += " ";


        // Verify header code below, can be comment

        if( aceHead->textureType==0 || aceHead->textureType==4 ||
            aceHead->textureType==1 || aceHead->textureType==5 ) {
                if( !( aceHead->colorType==0x0e && aceHead->colorDepth==3 ) &&
                    !( aceHead->colorType==0x10 && aceHead->colorDepth==4 ) &&
                    !( aceHead->colorType==0x11 && aceHead->colorDepth==5 ) ) {
                        errorMsg = "Wrong color type : "+AnsiString(aceHead->colorType);
                        return;
                 }

                if( aceHead->unknown1!=0 || aceHead->unknown2!=0 ) {
                        errorMsg = "Unknown value:"+AnsiString(aceHead->unknown1)
                                +":"+AnsiString(aceHead->unknown2);
                        return;
                 }
         }
        else if( aceHead->textureType==0x15 || aceHead->textureType==0x11 ||
                 aceHead->textureType==0x10 ) {
                if(aceHead->colorType!=0x12) {
                        errorMsg = "Wrong color type : "+AnsiString(aceHead->colorType);
                        return;
                 }

                if( !( (aceHead->unknown1==0x0e && colorDepth==Opaque) ||
                       (aceHead->unknown1==0x10 && colorDepth==Trans) )
                        || aceHead->unknown2!=0x12 ) {
                        errorMsg = "Unknown value:"+AnsiString(aceHead->unknown1)
                                +":"+AnsiString(aceHead->unknown2);
                        return;
                 }
         }
        else {
                errorMsg = "Wrong texture type:"+AnsiString(aceHead->textureType);
                return;
         }

        if( aceHead->reserved!=0 ||
            memcmp(aceHead->UnknownString,UnknownStr,16) ||
            memcmp(aceHead->FixedData,FixedTail,16*colorDepth) ) {
                errorMsg = "Fixed data compare mismatch";
                return;
         }
}
//---------------------------------------------------------------------------

bool AceFile::LoadFromFile(AnsiString FileName)
{
        if( !FileName.IsEmpty() )
                fileName = FileName;

        int zsize;
        KujuFileHead kujuhead;
        int handle=-1;
        HANDLE maphandle=NULL;
        unsigned char * filemapptr=NULL;

        if( dataBuffer )
                delete dataBuffer;

    try {
        try {
        // read file head & size
        handle = FileOpen(fileName,fmOpenRead);
        if( handle==-1 ) {
                errorMsg = "Can not open source file!";
                return false;
         }
        if( FileRead(handle,&kujuhead,sizeof(KujuFileHead))<sizeof(KujuFileHead) ) {
                errorMsg = "File too small!";
                return false;
         }
        fileSize = FileSeek(handle,0,2);
        FileSeek(handle,0,0);           // reset position

        // does kuju file
        if( !kujuhead.isKujuHead() ) {
                errorMsg = "Not kuju file!";
                return false;
         }

        if( kujuhead.isZCompressed() ) {
                // file memory map
                maphandle = CreateFileMapping( (void *)handle,NULL,
                                                PAGE_READONLY,0,0,NULL);
                filemapptr = (unsigned char *)MapViewOfFile(maphandle,FILE_MAP_READ,0,0,0);
                if( filemapptr==NULL ) {
                        errorMsg = "Fail to memory map file!";
                        return false;
                 }

                // decide Z buffer size
                if( kujuhead.dataSize<MAXZLIBBUFSIZE && kujuhead.dataSize>fileSize )
                        zsize = kujuhead.dataSize;
                else
                        zsize = NORMALZLIBBUFSIZE;
                // alloc memory
                dataBuffer = new unsigned char[zsize+sizeof(KujuFileHead)];
                if( dataBuffer==NULL ) {
                        OutOfMemoryError();                     // throw EOutOfMemory
                        errorMsg = "Fail to alloc memory!";
                        return false;
                 }


                // decompress
                unsigned long zbufsize = zsize;
                if( uncompress(filemapptr,&zbufsize,dataBuffer+sizeof(KujuFileHead),
                                fileSize-sizeof(KujuFileHead))!=Z_OK ) {
                        errorMsg = "Decompress ZLib data fail!";
                        delete dataBuffer;
                        return false;
                 }

                loadSize = zbufsize+sizeof(KujuFileHead);
                isZLib = true;
         }
        else {
                dataBuffer = new unsigned char[fileSize];
                if( dataBuffer==NULL ) {
                        OutOfMemoryError();                     // throw EOutOfMemory
                        errorMsg = "Fail to alloc memory!";
                        return false;
                 }

                if( FileRead(handle,dataBuffer,fileSize)!=fileSize ) {
                        errorMsg = "Read file fail!";
                        delete dataBuffer;
                        return false;
                 }

                loadSize = fileSize;
                isZLib = false;
         }

        if( loadSize <= sizeof(AceHead)+sizeof(KujuFileHead)+32 ) {
                 errorMsg = "Data size is too fail!";
                 delete dataBuffer;
                 return false;
          }

        kujuHead = (KujuFileHead *)dataBuffer;
        aceHead = (AceHead *)(dataBuffer+sizeof(KujuFileHead));

        parseHeader();

        if( !errorMsg.IsEmpty() ) {
                ShowMessage(errorMsg);
                infoMsg += errorMsg;
         }

        }
        catch (Exception &exception)
        {
            if(dataBuffer) delete dataBuffer;
            Application->ShowException(&exception);
            return false;
        }
     }
    __finally {
        if( filemapptr!=NULL ) UnmapViewOfFile(filemapptr);
        if( maphandle!=NULL ) CloseHandle(maphandle);
        if( handle!=-1 ) FileClose(handle);
     }

        return true; 
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------

AnsiString CompDecompKujuFile(const AnsiString srcname,const AnsiString destname,
                                bool compress,float ratio,int compresslevel)         // thresold for compress ratio
{
        int filesize,zsize;
        KujuFileHead khead;

        int srchandle=-1,desthandle=-1;
        unsigned char * buffer1=NULL;
        unsigned char * buffer2=NULL;
        HANDLE maphandle=NULL;

    try {
//        try {
        // read file head
        srchandle = FileOpen(srcname,fmOpenRead);
        if( srchandle==-1 )
                return " Can not open source file!";
        if( FileRead(srchandle,&khead,sizeof(KujuFileHead))<sizeof(KujuFileHead) )
                return " File too small!";
        filesize = FileSeek(srchandle,0,2);
        FileSeek(srchandle,0,0);           // reset position

        // decide Z buffer size
        if( khead.isZCompressed() ) {
                if( compress )
                        return " File already ZLib compressed!";

                if( khead.dataSize<MAXZLIBBUFSIZE && khead.dataSize>filesize )
                        zsize = khead.dataSize;
                else
                        zsize = NORMALZLIBBUFSIZE;
         }
        else if( khead.notZCompressed() ) {
                if( !compress ) {
                        FileClose(srchandle);
                        return " File not ZLib compressed!";
                 }

                 zsize = filesize+filesize/1000;         // Data+16  must>0.1%+12bytes
         }
        else
                return " Invaild file head!";


        // prepare buffer & file memory map
        maphandle = CreateFileMapping( (void *)srchandle,NULL,
                                        PAGE_READONLY,0,0,NULL);
        buffer1 = (unsigned char *)MapViewOfFile(maphandle,FILE_MAP_READ,0,0,0);
        buffer2 = new unsigned char[zsize];

        if( buffer2==NULL || buffer1==NULL )
                return " Memory alloc or file map fail!";

        // do compress or uncompress
        unsigned long zbufsize = zsize;
        int zcode;
        if( compress )
                zcode = compress2(buffer2,&zbufsize,buffer1+sizeof(KujuFileHead),
                                filesize-sizeof(KujuFileHead),compresslevel);
        else
                zcode = uncompress(buffer2,&zbufsize,buffer1+sizeof(KujuFileHead),
                                filesize-sizeof(KujuFileHead));
        if( zcode!=Z_OK )
                return " Decompress/Compress ZLib data fail!";

        // if ZLib compressed size is not small enough
        float compratio = (float)zbufsize/(filesize-sizeof(KujuFileHead));
        if( compratio >= ratio )
                return "SKIP" + FloatToStrF(100*compratio,ffNumber,18,1) + "%";

        // write file
        desthandle = FileCreate(destname);
        if( desthandle==-1 )
                return " Can not open save file!";
        if( compress )
                khead.prepareCompressedHead(filesize-sizeof(KujuFileHead));
        else
                khead.prepareUnCompressedHead();
        if( FileWrite(desthandle,&khead,sizeof(KujuFileHead))!=sizeof(KujuFileHead) )
                return " File write error!";
        if( FileWrite(desthandle,buffer2,zbufsize)!=(int)zbufsize )
                return " File write error!";
/*        }                             // there are problem let catch and __finally work together
        catch (Exception &exception)
        {
            Application->ShowException(&exception);
            return " ZLib compress or write file error!";
        }       */
     }
    __finally {
        if( buffer1!=NULL ) UnmapViewOfFile(buffer1);
        if( maphandle!=NULL ) CloseHandle(maphandle);
        if( srchandle!=-1 ) FileClose(srchandle);
        if( buffer2!=NULL ) delete buffer2;
        if( desthandle!=-1 ) FileClose(desthandle);
     }

        return AnsiString ();
}
//---------------------------------------------------------------------------



