//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <stdio.h>

#include "aceopt.h"
#include "mylib.h"

#pragma package(smart_init)


//---------------------------------------------------------------------------
// extern       need set in main.cpp
AnsiString makeacepath;
AnsiString extraexepath;

//---------------------------------------------------------------------------
// struct Pic define in mwace.h

struct Pic
{
	long width;
	long height;

	long depth;
	long numcols;
	FILE* fin;
	char comment[80];
	unsigned char cmap[768];
    	void* jlib;
    	void* tlib;
	void* plib;
	unsigned char*buff;
	FILE* fout;
	void *ptr;
	void(*progress)(int,int);
	void* ilib;
	long stype;
	unsigned char spare[120];
};
//---------------------------------------------------------------------------
// MW Graphics dll function

/*      function needed define in mwace.h
extern "C" __declspec(dllimport) int  AceToTga(char*inace,char*outtga);
extern "C" __declspec(dllimport) int  AceToTgaSquare(char*inace,char*outtga);
extern "C" __declspec(dllimport) int  CheckAce(char*inace,struct Pic*);
extern "C" __declspec(dllimport) int  AceCompress(char*inace,char*outace);
*/

typedef int (*ACETOTGASQUARE)(char*,char*);
typedef int (*ACETOTGA)(char*,char*);
typedef int (*CHECKACE)(char*,Pic*);
typedef int (*ACECOMPRESS)(char*,char*);

/*      function TGAtoACE & DXTSetMipFilter define in mwdds.h

#define TF_DXT1            10
#define TF_DXT1_1BitAlpha  11

extern "C" __declspec(dllimport) int TGAtoACE(
		char * infile, 			// TGA file
                DWORD TextureFormat, 		// list below (DXT1 or DXT1a only!)
                bool bGenMipMaps,    		// auto gen MIP maps
                bool bDither,			// use dither for 16 bit
                char*fname);			// output ACE filename

enum MIPFilterTypes
{
    kMIPFilterPoint ,                   
    kMIPFilterBox ,
    kMIPFilterTriangle ,
    kMIPFilterQuadratic ,
    kMIPFilterCubic ,
    kMIPFilterCatrom ,
    kMIPFilterMitchell ,
    kMIPFilterGaussian ,
    kMIPFilterSinc ,
    kMIPFilterBessel ,
    kMIPFilterHanning ,
    kMIPFilterHamming ,
    kMIPFilterBlackman ,
    kMIPFilterKaiser,
    kMIPFilterLast,
};

extern "C" __declspec(dllimport) int  DXTSetMipFilter(short typ);
*/


#define TF_DXT1            10
#define TF_DXT1_1BitAlpha  11
typedef int (*TGATOACE)(char *,DWORD,bool,bool,char*);
typedef int (*DXTSETMIPFILTER)(short);


HINSTANCE mwace;
HINSTANCE mwdds;

ACETOTGASQUARE AceToTgaSquare;
ACETOTGA AceToTga;
CHECKACE CheckAce;
ACECOMPRESS AceCompress;

TGATOACE TGAtoACE;
DXTSETMIPFILTER DXTSetMipFilter;

//---------------------------------------------------------------------------

bool LoadMwace()
{
        mwace = LoadLibrary("mwace");
        if( !mwace ) return false;

        AceToTgaSquare = (ACETOTGASQUARE)GetProcAddress(mwace,"_AceToTgaSquare");
        AceToTga = (ACETOTGA)GetProcAddress(mwace,"_AceToTga");
        CheckAce = (CHECKACE)GetProcAddress(mwace,"_CheckAce");
        AceCompress = (ACECOMPRESS)GetProcAddress(mwace,"_AceCompress");
        return AceToTgaSquare!=NULL && AceToTga!=NULL
                && CheckAce!=NULL && AceCompress!=NULL;
}
//---------------------------------------------------------------------------

bool LoadMwdds()
{
        mwdds = LoadLibrary("mwdds");
        if( !mwdds ) return false;

        TGAtoACE = (TGATOACE)GetProcAddress(mwdds,"TGAtoACE");
        DXTSetMipFilter = (DXTSETMIPFILTER)GetProcAddress(mwdds,"DXTSetMipFilter");

        return TGAtoACE!=NULL && DXTSetMipFilter!=NULL;
}
//---------------------------------------------------------------------------

int GetMWDDSVersion()
{
        char buff[1024];
        void* ptr;
        unsigned int ii;
        int ms,ls;
        VS_FIXEDFILEINFO *ff;

        ls=0;  //return value for failure
        if(GetFileVersionInfo( "mwdds.dll",NULL,1020,buff))
        {
                if( VerQueryValue(buff,"\\",(void**)&ff,&ii))
                {
//                        ms=(ff->dwProductVersionMS)>>16;    //the Major version number - 4
                        ls=(ff->dwProductVersionLS);        //the minor version number - 47 or whatever it is
                }
        }
        return ls;
}
//---------------------------------------------------------------------------

void UnloadMwace()
{
        if( mwace) FreeLibrary(mwace);
}
//---------------------------------------------------------------------------

void UnloadMwdds()
{
        if( mwdds) FreeLibrary(mwdds);
}
//---------------------------------------------------------------------------
/*
// Check ACE Format, while file format error return colorDepth = Unknown
AceInfo GetAceInfo(AnsiString path)
{
        Pic pic;
        AceInfo aceinfo;

        aceinfo.compressType = NoCompress;

        try
        {

        // Call mwace.dll CheckAce()
        (*CheckAce)( path.c_str(),&pic );

        }
        catch (Exception &exception)
        {
                Application->ShowException(&exception);
        }

        aceinfo.width = pic.width;
        aceinfo.height = pic.height;
        aceinfo.infoMsg = pic.comment;

        if( aceinfo.infoMsg.Pos("DXT1 Opaque") ) {
                aceinfo.compressType = DXT1;
                aceinfo.colorDepth = Opaque;
         }
        else if( aceinfo.infoMsg.Pos("DXT1 + Alpha") ) {
                aceinfo.compressType = DXT1;
                aceinfo.colorDepth = Trans;
         }
        else if( aceinfo.infoMsg.Pos("24 bit+Trans") )
                aceinfo.colorDepth = Trans;
        else if( aceinfo.infoMsg.Pos("24 bit") )
                aceinfo.colorDepth = Opaque;
        else if( aceinfo.infoMsg.Pos("32 bit") )
                aceinfo.colorDepth = Alpha;
        else
                aceinfo.colorDepth = Unknown;            // Unknown format

        if( aceinfo.infoMsg.Pos("(Compressed)")) {
                if( aceinfo.compressType== DXT1 )
                        aceinfo.compressType = DXT1ZLib;
                else
                        aceinfo.compressType = ZLib;
         }

        return aceinfo;
}

//---------------------------------------------------------------------------

AnsiString MwaceZLibComp(AnsiString acename,AnsiString destname)
{
    try {
        if( AceCompress(acename.c_str(),destname.c_str())==0 )
                return AnsiString ();
    }
    catch (Exception &exception)
    {
            Application->ShowException(&exception);
    }
        return "    mwace failed to compress ZLib format!";
}
*/
//---------------------------------------------------------------------------

int AceToTgaMwace(AnsiString acename,AnsiString tganame,bool square)
{
        if( !square )
                return (*AceToTga)(acename.c_str(),tganame.c_str());
        else
                return (*AceToTgaSquare)(acename.c_str(),tganame.c_str());
}
//---------------------------------------------------------------------------

AnsiString TgaToDXTAceUseMwdds(AnsiString tganame,AnsiString destname,
        ACEColorDepths colordepth,bool dither,int mipfmode)
{
        int tf_dxt;

        if( colordepth==Opaque ) tf_dxt = TF_DXT1;
        else tf_dxt = TF_DXT1_1BitAlpha;
    try {
        if( mipfmode!=0 )       // FILTER_KAISER ... mode is very slowly
                (*DXTSetMipFilter)( (short)(1+mipfmode) );      // no Point Filter

        if( (*TGAtoACE)(tganame.c_str(),tf_dxt,true,
                        dither,                           // dither
                        destname.c_str()) )
                return AnsiString ();
    }
    catch (Exception &exception)
    {
            Application->ShowException(&exception);
    }

        return "    mwdds failed to compress DXT format!";
}
//---------------------------------------------------------------------------

/*
Usage: MakeACE <in file> <out file> [options]
Options: -trans         Alpha channel contains transparency mask
         -flip          Flip the source to handle images which
                        have an inverted origin
         -zlib          Use ZLib compression
         -dxt           Use DXT compression for solid or one-bit
                        transparency images
         -bmp           Source image is a bitmap (not a texture)
         -width:<nnn>   Clamp image width to specified size
         -height:<nnn>  Clamp image height to specified size
*/
AnsiString TgaToAceUseMakeAce(ACECompressType compmethod,
        AnsiString tganame,AnsiString destname,ACEColorDepths colordepth,
        int width,int height)
{
        AnsiString cmdline (makeacepath);

        cmdline += " \""+tganame+"\" \""+destname+"\"";

        if( compmethod==ZLib2D || width>512 || height>512 ) {
                cmdline += " -zlib -bmp -width:"+AnsiString(width)
                                    +" -height:"+AnsiString(height);
         }
        else if( compmethod==ZLib )
                cmdline += " -zlib";
        else if( compmethod==DXT1 || compmethod==DXT1ZLib )
                cmdline += " -dxt";

        if( colordepth==Trans )
                cmdline += " -trans";

    try {
        if( ExecAndWait(cmdline.c_str(),SW_HIDE) ) return AnsiString ();
    }
    catch (Exception &exception)
    {
            Application->ShowException(&exception);
    }
        return "    Failed to run MakeACE.exe!";
}
//---------------------------------------------------------------------------

/*
aceit.exe <input file> [output file] [options]

dxt (or d)
This specifies that the output will be in the DXT1 format. This can only be used if the image is square dimensions 2n. If an alpha channel is present on the source, transparency will be applied to the output. You will receive an error if the input image does not meet these criteria. Click here for a more detailed explanation of the DXT1 ACE format. This cannot be used with any other options except quiet.

uncompressed (or u)
This specifies that the output file will be uncompressed RGB. (The default is ZLib-compressed RGB.)

trans (or t)
This specifies that the output will be 24-bit RGB color, 1 bit alpha (or 'trans'). Click here for a more detailed explanation of the RGB ACE format. This cannot be specified with the alpha option.

alpha (or a)
This specifies that the output will be 24-bit RGB color, 8 bit alpha (or 'alpha'). Click here for a more detailed explanation of the RGB ACE format. This cannot be specified with the trans option.

cab (or c)
This specifies that no MIP maps will be added to the output image, like for cab bitmaps. This is always on for non-square, non 2n images.

quiet (or q)

aceit.exe "c:\my documents\input.bmp" "c:\my documents\output\" /dxt /quiet
*/
AnsiString TgaToAceUseAceIt(ACECompressType compmethod,
        AnsiString tganame,AnsiString destname,ACEColorDepths colordepth)
{
        AnsiString cmdline (extraexepath);

        cmdline += " \""+tganame+"\" \""+destname+".ace\" /q";

        if( compmethod==ZLib2D) {
                cmdline += " /c";
                if( colordepth==Trans ) cmdline += " /t";
                else if( colordepth==Alpha ) cmdline += " /a";
         }
        else if( compmethod==ZLib ) {
                if( colordepth==Trans ) cmdline += " /t";
                else if( colordepth==Alpha ) cmdline += " /a";
         }
        else if( compmethod==DXT1 || compmethod==DXT1ZLib ) {
                cmdline += " /d";
         }

    try {
        if( ExecAndWait(cmdline.c_str(),SW_HIDE) ) {
                RenameFile(destname+".ace",destname);
                return AnsiString ();
         }
    }
    catch (Exception &exception)
    {
            Application->ShowException(&exception);
    }
        return "    Failed to run aceit.exe!";
}
//---------------------------------------------------------------------------

/*
remipit.exe <filename> [/s] [/u] [t/]
<filename> = .ace file to be remipped
[/s] = suppress popup messages (optional)
[/u] = leave output image uncompressed (optional)
[/t] = convert 8-bit alpha to 1-bit (trans) (optional)
*/
AnsiString ReMipAce(AnsiString acename,bool forcetrans)
{
        AnsiString cmdline (extraexepath);

        cmdline += " \""+acename+"\" /s";
        if( forcetrans ) cmdline += " /t";

    try {
        if( ExecAndWait(cmdline.c_str(),SW_HIDE) ) return AnsiString ();
    }
    catch (Exception &exception)
    {
            Application->ShowException(&exception);
    }
        return "    Failed to run remipit.exe!";
}
//---------------------------------------------------------------------------



