//---------------------------------------------------------------------------

#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include "cdiroutl.h"
#include <Grids.hpp>
#include <Outline.hpp>
#include <FileCtrl.hpp>

#include "aceopt.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *BackPanel;
        TStatusBar *StatusBar;
        TPanel *TopPanel;
        TEdit *DirEdit;
        TButton *SelectDirButton;
        TButton *CompressButton;
        TPageControl *PageControl;
        TTabSheet *LogTabSheet;
        TTabSheet *TextureTypeOptionsTabSheet;
        TGroupBox *Check2DCondGroupBox;
        TLabel *DenyPDirLabel;
        TLabel *DenyPPDirLabel;
        TLabel *DenyPathContainLabel;
        TLabel *DenyFileInSameDirLabel;
        TLabel *DenyTextureNameLabel;
        TEdit *DenyPDirEdit;
        TEdit *DenyPPDirEdit;
        TEdit *DenyPathContainPhaseEdit;
        TEdit *DenyFileInSameDirEdit;
        TEdit *DenyTextureNameEdit;
        TMemo *LogMemo;
        TGroupBox *Check3DCondGroupBox;
        TLabel *AllowPDirLabel;
        TLabel *AllowPPDirLabel;
        TEdit *AllowPDirEdit;
        TEdit *AllowPPDirEdit;
        TEdit *PathMustContainEdit;
        TCheckBox *Check3DCheckBox;
        TCheckBox *SkipNoOpMsgCheckBox;
        TCheckBox *SkipNormCompMsgCheckBox;
        TCheckBox *CheckOnlyCheckBox;
        TLabel *SelectDirLabel;
        TButton *StopButton;
        TTabSheet *MiscOptionTabSheet;
        TGroupBox *BackupOptionGroupBox;
        TGroupBox *CompressOptionGroupBox;
        TCheckBox *UseMwddsCheckBox;
        TCheckBox *UseAceItForAllCheckBox;
        TEdit *ExtProgPathEdit;
        TLabel *SelectExePathLabel;
        TRadioButton *NoBackupRadioButton;
        TRadioButton *AddExtBackupRadioButton;
        TRadioButton *MoveFileBackupRadioButton;
        TEdit *BackupDirEdit;
        TEdit *ExtEdit;
        TCheckBox *VerifyZLibCompCheckBox;
        TCheckBox *NoBackupZLibCheckBox;
        TCheckBox *ReMipIt1024CheckBox;
        TCheckBox *AceIt1024DXTCheckBox;
        TCheckBox *AceIt1024ZLibCheckBox;
        TButton *SelectBackupDirButton;
        TCheckBox *ReMipItCheckBox;
        TButton *SelectExePathButton;
        TOpenDialog *OpenDialog;
        TLabel *NoDXTFileNameLabel;
        TEdit *NoDXTFileNameEdit;
        TCheckBox *KeepTGAFileCheckBox;
        TCheckBox *DitherCheckBox;
        TCheckBox *UseBuiltinZLibCompCheckBox;
        TCheckBox *RecurseDirCheckBox;
        TButton *CopyToClipboardButton;
        TButton *HelpButton;
        TCheckBox *DXTOnlyCheckBox;
        TLabel *MipFilterLabel;
        TComboBox *MipFilterComboBox;
        TCheckBox *KeepTempFileCheckBox;
        TCheckBox *PutCompToBckDirCheckBox;
        TTabSheet *CompressOptionsTabSheet;
        TGroupBox *MipMapGroupBox;
        TCheckBox *AddMipTo3DCheckBox;
        TCheckBox *NoMipFor2DCheckBox;
        TCheckBox *AddMip1024OnlyCheckBox;
        TGroupBox *DXTOptionGroupBox;
        TGroupBox *ZLibOptionGroupBox;
        TGroupBox *GroupBox1;
        TCheckBox *ForceDXTCheckBox;
        TCheckBox *ForceTransCheckBox;
        TCheckBox *DXTZlibCheckBox;
        TLabel *CompressRatioLabel;
        TEdit *CompressRatioEdit;
        TLabel *CompressRatioLabel2;
        TLabel *CompressLevelLabel;
        TComboBox *CompressLevelComboBox;
        TLabel *PathMustContainLabel;
        TCheckBox *NoDXTCheckBox;
        void __fastcall CompressButtonClick(TObject *Sender);
        void __fastcall SelectDirButtonClick(TObject *Sender);
        void __fastcall CheckOnlyCheckBoxClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall SkipNormCompMsgCheckBoxClick(TObject *Sender);
        void __fastcall Check3DCheckBoxClick(TObject *Sender);
        void __fastcall NoDXTCheckBoxClick(TObject *Sender);
        void __fastcall VerifyZLibCompCheckBoxClick(TObject *Sender);
        void __fastcall UseAceItForAllCheckBoxClick(TObject *Sender);
        void __fastcall StopButtonClick(TObject *Sender);
        void __fastcall PageControlChange(TObject *Sender);
        void __fastcall SelectBackupDirButtonClick(TObject *Sender);
        void __fastcall SelectExePathButtonClick(TObject *Sender);
        void __fastcall ExtEditExit(TObject *Sender);
        void __fastcall ForceTransCheckBoxClick(TObject *Sender);
        void __fastcall StatusBarResize(TObject *Sender);
        void __fastcall CopyToClipboardButtonClick(TObject *Sender);
        void __fastcall HelpButtonClick(TObject *Sender);
        void __fastcall KeepTGAFileCheckBoxClick(TObject *Sender);
        void __fastcall NoBackupRadioButtonClick(TObject *Sender);
        void __fastcall UseMwddsCheckBoxClick(TObject *Sender);
        void __fastcall AddMipTo3DCheckBoxClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
        __fastcall TMainForm(TComponent* Owner);

        void ProcessOneDir(AnsiString DirName);
        AnsiString ProcessOneFile(AnsiString path,AnsiString fname,
                int filesize,int dirallow3d,AnsiString backupdir,int &msglevel);
        AnsiString DoCompress(AnsiString path,AnsiString fname,
                int filesize,AceInfo aceinfo,ACECompressType compmethod,
                AnsiString backupdir,int &msglevel);

        int CheckDirTextureType(AnsiString path);     // 0 2D, 1 3D, -1 Unknown
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;

//---------------------------------------------------------------------------
#endif
