//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <Registry.hpp>
#include <Masks.hpp>

#include "mylib.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

// Lib function below
//---------------------------------------------------------------------------

AnsiString GetRegistryValue(AnsiString KeyName,AnsiString ValueName)
{
  AnsiString S;
  TRegistry *Registry = new TRegistry;
  try
  {
    Registry->RootKey = HKEY_LOCAL_MACHINE;
    // false because we do not want to create it if it doesnt exist
    Registry->OpenKey(KeyName, false);
    S = Registry->ReadString(ValueName);
  }
  __finally
  {
    delete Registry;
  }
  return S;

}
//---------------------------------------------------------------------------

void DoMessageLoop()            // Used for allow GUI can process message while long time task run
{
        MSG  amsg;

        while( PeekMessage(&amsg,NULL,0,0,PM_REMOVE) )
        {
                TranslateMessage(&amsg);
                DispatchMessage(&amsg);
        }
}
//---------------------------------------------------------------------------

bool ExecAndWait(char *cmdline,WORD showwindow,char *curdir)
{
        STARTUPINFO startupinfo;
        PROCESS_INFORMATION process_info;

        startupinfo.cb = sizeof(STARTUPINFO);
        startupinfo.lpReserved = NULL;
        startupinfo.lpDesktop = NULL;
        startupinfo.lpTitle = NULL;
        startupinfo.dwX = 0;
        startupinfo.dwY = 0;
        startupinfo.dwXSize = 0;
        startupinfo.dwYSize = 0;
        startupinfo.dwXCountChars = 0;
        startupinfo.dwYCountChars = 0;
        startupinfo.dwFillAttribute = 0;
        startupinfo.dwFlags = STARTF_USESHOWWINDOW;
        startupinfo.wShowWindow = showwindow;
        startupinfo.cbReserved2 = 0;
        startupinfo.lpReserved2 = NULL;
        startupinfo.hStdInput = 0;
        startupinfo.hStdOutput = 0;
        startupinfo.hStdError = 0;

        if( !CreateProcess(NULL,
                      cmdline,
                      NULL,
                      NULL,
                      false,
                      0,
                      NULL,
                      curdir,
                      &startupinfo,
                      &process_info) )
                return false;

        // wait process finish
        WaitForSingleObject(process_info.hProcess,INFINITE);

        return true;
}
//---------------------------------------------------------------------------

void SplitString(TStringList *strlist,AnsiString str,char delimiter)
{
        int first=1;

        strlist->Clear();
        for(int i=1;i<=str.Length();i++) {
                if( str[i]==delimiter ) {
                        if( i>first )           // avoid empty string
                                strlist->Add( str.SubString(first,i-first) );
                        first = i+1;
                 }
         }
        strlist->Add( str.SubString(first,str.Length()-first+1) );
}
//---------------------------------------------------------------------------

bool MatchesMaskStrings(TStringList *wildcards,AnsiString fname)   // wildcard strings
{
        for(int i=0;i<wildcards->Count;i++)
                if( MatchesMask(fname,wildcards->Strings[i]) )
                        return true;

        return false;
}
//---------------------------------------------------------------------------

int CaseInsensCheck(TStringList *strlist,AnsiString str)
{
        for(int i=0;i<strlist->Count;i++)
                if( str.AnsiCompareIC(strlist->Strings[i])==0 )
                        return i;

        return -1;
}
//---------------------------------------------------------------------------

int CaseInsensCheck(TStringList *strlist,TStringList *strlist2)
{
        for(int i=0;i<strlist->Count;i++)
            for(int j=0;j<strlist2->Count;j++)
                if( strlist->Strings[i].AnsiCompareIC(strlist2->Strings[j])==0 )
                        return i;

        return -1;
}
//---------------------------------------------------------------------------

int CaseInsensPos(AnsiString str,AnsiString phase)
{
        int len = phase.Length();

        for(int i=1;i<=str.Length();i++)
                if( phase.AnsiCompareIC(str.SubString(i,len))==0 )
                        return i;

        return 0;
}
//---------------------------------------------------------------------------

int getfilesize(AnsiString fname)
{
        int handle,size;

        handle = FileOpen(fname,fmOpenRead);
        if( handle==-1 ) return -1;

        size = FileSeek(handle,0,2);

        FileClose(handle);
        return size;
}
//---------------------------------------------------------------------------

int comparefilebinary(AnsiString fname1,AnsiString fname2)
                // o for equal, -1 for error, -2 for memory alloc fail
                // 1 for not equal, 2 for content not equal,
{
        int handle1,handle2,fsize1,fsize2;
        char * buffer1;
        char * buffer2;

    try {
        handle1 = FileOpen(fname1,fmOpenRead);
        if( handle1==-1) return -1;
        fsize1 = FileSeek(handle1,0,2);
        if( fsize1==-1) return -1;

        handle2 = FileOpen(fname2,fmOpenRead);
        if( handle2==-1) return -1;
        fsize2 = FileSeek(handle2,0,2);
        if( fsize2==-1) return -1;

        if( fsize1!=fsize2 ) return 1;

        if( fsize2>=BUFFERSIZE ) fsize2 = BUFFERSIZE;
                // Use buffer to read may be better than use File memory map
                // for it can define pre-read size to avoid too many disk head seek

        buffer1 = new char[fsize2*2];
        if( buffer1==NULL ) {
                OutOfMemoryError();                     // throw EOutOfMemory
                return -2;
         }
        buffer2 = buffer1+fsize2;

        int count;
        FileSeek(handle1,0,0);
        FileSeek(handle2,0,0);
        for(int i=0;i<(fsize1+fsize2-1)/fsize2;i++) {
                count = FileRead(handle1,buffer1,fsize2);
                FileRead(handle2,buffer2,fsize2);

                if( memcmp(buffer1,buffer2,count)!=0 )
                        return 2;
         }
     }
    __finally {
        FileClose(handle1);
        FileClose(handle2);
        if( buffer1!=NULL ) delete buffer1;             // don't delete buffer2
     }
        return 0;
}
//---------------------------------------------------------------------------
